##############################################################################
#
# Copyright (C) 2006-2013 Red Hat, Inc. All rights reserved.
#
# This copyrighted material is made available to anyone wishing to use,
# modify, copy, or redistribute it subject to the terms and conditions
# of the GNU General Public License version 2.
#
###############################################################################


%define PEGASUS_PROVIDERS_DIR %{_libdir}/Pegasus/providers


############ SRPM ###################


Name: clustermon
Version: 0.12.1
Release: 10.0.1%{?dist}
License: GPLv2
URL: http://sources.redhat.com/cluster/conga

Group: System Environment/Base
Summary: Monitoring and management of Enterprise Linux Cluster Suite

Source0: %{name}-%{version}.tar.gz
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: cman-devel
BuildRequires: glibc-devel gcc-c++ libxml2-devel
BuildRequires: openssl-devel dbus-devel pam-devel pkgconfig
BuildRequires: net-snmp-devel tog-pegasus-devel

Patch1: bz736814.patch
Patch2: bz618321-1.patch
Patch3: bz618321-2.patch
Patch4: bz618321-3.patch
Patch5: bz618321-4.patch
Patch6: bz618321-5.patch
Patch7: bz618321-6.patch
Patch8: bz618321-7.patch
Patch9: bz618321-8.patch
Patch10: bz882277.patch
Patch11: bz957798-fix_for_cman_get_node_call.patch

# Patch 100..199 are for SNMP subsystem
Patch101: bz504869-01-Fix-REDHAT-MIB-smilint-issues.patch
Patch102: bz504869-02-Update-REDHAT-CLUSTER-MIB.patch
Patch103: bz504869-03-Add-rhcClusterConfigurationVersion-hand.patch
Patch104: bz504869-04-Fix-XML-comparison.patch
Patch105: bz504869-05-Fix-missing-definition.patch
Patch106: bz504869-06-Fix-config_version-presentation.patch
Patch107: bz504869-07-Add-node-ID-to-snmp-output.patch
Patch108: bz504869-08-Update-MIBs.patch
Patch109: bz504869-09-Add-cache-to-ClusterMonitor-objects.patch
Patch110: bz504869-10-Add-trap-support-to-SNMP-agent.patch
Patch111: bz504869-11-Fix-snmpd-README.patch
Patch112: bz504869-12-Put-OIDs-in-one-place.patch
Patch113: bz504869-13-Convert-traps-to-C.patch
Patch114: bz504869-14-Send-quorum-state-change-trap.patch
Patch115: bz504869-15-Cache-quorum-and-vote-states.patch
Patch116: bz504869-16-Add-SNMP-traps-for-services-node-events.patch
Patch117: bz504869-17-Clean-up-MIB-add-missing-notification.patch
Patch118: bz847289.patch
Patch119: bz965792-fix_for_stack_overflow_caused_by_very_large_cluster_conf_files.patch
Patch1000: clustermon-oracle-enterprise.patch

%description
This package contains Enterprise Linux Cluster Suite
SNMP/CIM module/agent/provider.


%prep
%setup -q

# BZ504869 - SNMP traps & BZ241464 - SNMP definitions fail smilint
%patch101 -p1 -b .bz504869.1
%patch102 -p1 -b .bz504869.2
%patch103 -p1 -b .bz504869.3
%patch104 -p1 -b .bz504869.4
%patch105 -p1 -b .bz504869.5
%patch106 -p1 -b .bz504869.6
%patch107 -p1 -b .bz504869.7
%patch108 -p1 -b .bz504869.8
%patch109 -p1 -b .bz504869.9
%patch110 -p1 -b .bz504869.10
%patch111 -p1 -b .bz504869.11
%patch112 -p1 -b .bz504869.12
%patch113 -p1 -b .bz504869.13
%patch114 -p1 -b .bz504869.14
%patch115 -p1 -b .bz504869.15
%patch116 -p1 -b .bz504869.16
%patch117 -p1 -b .bz504869.17
%patch118 -p1 -b .bz847289
%patch119 -p1 -b .bz965792.1

%patch1 -p1 -b .bz736814
%patch2 -p1 -b .bz618321-1
%patch3 -p1 -b .bz618321-2
%patch4 -p1 -b .bz618321-3
%patch5 -p1 -b .bz618321-4
%patch6 -p1 -b .bz618321-5
%patch7 -p1 -b .bz618321-6
%patch8 -p1 -b .bz618321-7
%patch9 -p1 -b .bz618321-8
%patch10 -p1 -b .bz882277
%patch11 -p1 -b .bz957798.1
%patch1000 -p1


%build
%configure		--arch=%{_arch} \
		--docdir=%{_docdir} \
		--pegasus_providers_dir=%{PEGASUS_PROVIDERS_DIR} \
		--include_zope_and_plone=no

make %{?_smp_mflags} clustermon

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} install_clustermon

%clean
rm -rf %{buildroot}



### cluster module ###


%package -n modcluster
Group: System Environment/Base
Summary: Enterprise Linux Cluster Suite - remote management

Requires: oddjob dbus openssl
Requires: initscripts util-linux
Requires(post): chkconfig initscripts util-linux
Requires(preun): chkconfig initscripts
Requires(postun): initscripts util-linux
Conflicts: clumon
Conflicts: ricci-modcluster

%description -n modcluster
Management module for Enterprise Linux Cluster Suite.


%files -n modcluster
%defattr(-,root,root)
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/modcluster.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/modcluster.systembus.conf
			%{_sysconfdir}/rc.d/init.d/modclusterd
			%{_libexecdir}/modcluster
			%{_sbindir}/modclusterd
			%{_docdir}/modcluster-%{version}/


%post -n modcluster
/sbin/chkconfig --add modclusterd
DBUS_PID=`cat /var/run/messagebus.pid 2>/dev/null`
/bin/kill -s SIGHUP $DBUS_PID >&/dev/null
# It's ok if this fails (it will fail when oddjob is not running).
/sbin/service oddjobd reload >&/dev/null
exit 0

%preun -n modcluster
if [ "$1" == "0" ]; then
	/sbin/service modclusterd stop >&/dev/null
	/sbin/chkconfig --del modclusterd
fi
exit 0

%postun -n modcluster
if [ "$1" == "0" ]; then
	DBUS_PID=`cat /var/run/messagebus.pid 2> /dev/null`
	/bin/kill -s SIGHUP $DBUS_PID >&/dev/null
	/sbin/service oddjobd reload >&/dev/null
fi
if [ "$1" == "1" ]; then
	/sbin/service modclusterd condrestart >&/dev/null
fi
exit 0


### cluster-snmp ###


%package -n cluster-snmp
Group: System Environment/Base
Summary: Enterprise Linux Cluster Suite - SNMP agent

Requires: modcluster = %{version}-%{release}
Requires: net-snmp
Requires: oddjob openssl
Requires(post): initscripts
Requires(postun): initscripts
Conflicts: clumon-snmp

%description -n cluster-snmp
SNMP agent for Enterprise Linux Cluster Suite.

%files -n cluster-snmp
%defattr(-,root,root)
			%{_libdir}/cluster-snmp/
			%{_datadir}/snmp/mibs/REDHAT-MIB
			%{_datadir}/snmp/mibs/REDHAT-CLUSTER-MIB
			%{_docdir}/cluster-snmp-%{version}/

%post -n cluster-snmp
/sbin/service snmpd condrestart >&/dev/null
exit 0

%postun -n cluster-snmp
# don't restart snmpd twice on upgrades
if [ "$1" == "0" ]; then
	/sbin/service snmpd condrestart >&/dev/null
fi
exit 0



### cluster-cim ###

%package -n cluster-cim
Group: System Environment/Base
Summary: Enterprise Linux Cluster Suite - CIM provider

Requires: modcluster = %{version}-%{release}
Requires: tog-pegasus
Requires: oddjob openssl
Requires(post): initscripts
Requires(postun): initscripts
Conflicts: clumon-cim

%description -n cluster-cim
CIM provider for Enterprise Linux Cluster Suite.

%files -n cluster-cim
%defattr(-,root,root)
			%{PEGASUS_PROVIDERS_DIR}/libRedHatClusterProvider.so
			%{_docdir}/cluster-cim-%{version}/

%post -n cluster-cim
# pegasus might not be running, don't fail
/sbin/service tog-pegasus condrestart >&/dev/null
exit 0

%postun -n cluster-cim
# don't restart pegasus twice on upgrades
if [ "$1" == "0" ]; then
	/sbin/service tog-pegasus condrestart >&/dev/null
fi
# pegasus might not be running, don't fail
exit 0






###  changelog ###


%changelog
* Thu Jul 18 2013 Kevin Lyons <kevin.x.lyons@oracle.com> 0.12.1-10.0.1
- replace "Red Hat Enterprise Linux" with "Enterprise Linux"
  in spec file and tarball's spec file

* Wed May 22 2013 Ryan McCabe <rmccabe@redhat.com> - 0.12.1-10
- Fix for stack overflow caused by very large cluster.conf files
  Resolves: rhbz#965792

* Tue Apr 30 2013 Ryan McCabe <rmccabe@redhat.com> - 0.12.1-9
- modcluster: Fix for cman_get_node() call
  Resolves: rhbz#957798

* Mon Apr 22 2013 Jan Pokorny <jpokorny@redhat.com> 0.12.1-8
- Fix bz847289 (cluster-snmp module may cause net-snmp to SEGV when told to reload)
- Fix bz882277 (cluster-cim: missing symbols/provider library not compiled properly)

* Thu Nov 24 2011 Jan Pokorny <jpokorny@redhat.com> 0.12.1-7
- Performance improvements connected with bz618321.
- Related: bz618321

* Mon Nov 21 2011 Jan Pokorny <jpokorny@redhat.com> 0.12.1-5
- Fix bz618321 (modclusterd memory footprint is growing over time)

* Fri Oct 21 2011 Ryan McCabe <rmccabe@redhat.com> 0.12.1-4
- Fix bz736814 (Create new cluster fails with luci when installing packages)

* Wed Jul 14 2010 Lon Hohberger <lhh@redhat.com> 0.12.1-3
- Implement SNMP traps and clean up MIBs
- Resolves: rhbz#504869 rhbz#241464

* Wed Jul 30 2008 Ryan McCabe <rmccabe@redhat.com> 0.12.1-2
- Fix bz453600 (cluster-snmp deadlocks snmpd)

* Thu Apr 10 2008 Ryan McCabe <rmccabe@redhat.com> 0.12.1-1
- Fix bz441947 (cluster-snmp dlopen failure)

* Thu Mar 27 2008 Ryan McCabe <rmccabe@redhat.com> 0.12.0-7
- Fix bz439186

* Wed Mar 19 2008 Ryan McCabe <rmccabe@redhat.com> 0.12.0-6
- Fix bz206570 (RFE: vm list from ricci)

* Tue Feb 12 2008 Ryan McCabe <rmccabe@redhat.com> 0.12.0-5
- Fix bz432534 (clustermon should not attempt to start or stop the cmirror service)

* Mon Jan 28 2008 Ryan McCabe <rmccabe@redhat.com> 0.12.0-2
- Run the cmirror init script when starting cluster nodes that use shared storage.
- Related: bz430737

* Mon Jan 21 2008 Ryan McCabe <rmccabe@redhat.com> 0.12.0-1
* Fixed bz317541 (Conga displays quorum status incorrectly when qdisk is used)

* Mon Aug 20 2007 Ryan McCabe <rmccabe@redhat.com> 0.10.0-5
- Fixed bz253341 (failure to start cluster service which had been modifed for correction)
- Resolves: bz253341

* Wed Aug 08 2007 Ryan McCabe <rmccabe@redhat.com> 0.10.0-4
- Fixed bz230451 (fence_xvm.key file is not automatically created. Should have a least a default)
- Resolves: bz230451

* Mon Jul 30 2007 Ryan McCabe <rmccabe@redhat.com> 0.10.0-3
- Fixed bz249351 (conga reports that ricci agent is unresponsive even though it's running)

* Wed Jun 27 2007 Ryan McCabe <rmccabe@redhat.com> 0.10.0-1
- Performance improvements.
- Make the clustermon init script more LSB-compliant
- Related: bz243701

* Wed Apr 11 2007 Ryan McCabe <rmccabe@redhat.com> 0.9.2-5
- Version bump
- Related: bz229027, bz230447, bz230452, bz230454, bz230457,
- Related: bz230461, bz230469, bz228637, bz233326, bz225747,
- Related: bz225206, bz225164, bz227758

* Wed Mar 28 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.9.2-4
- Do not fail on i18n machines
- Fixed bz225747 (Create/delete cluster - then access disk on node = Generic error on host: cluster tools: cman_tool errored)
- Fixed bz230454 (Unable to configure a virtual service)
- Resolves: bz225747, bz230454

* Tue Jan 23 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.8-30
- Version bump

* Wed Jan 17 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.8-29
- Version bump

* Wed Jan 17 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.8-28
- Version bump

* Wed Jan 10 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.8-27
- Improved bz218941: Conga/luci - cannot add node to cluster via luci web app

* Tue Dec 12 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-26
- Version bump

* Thu Nov 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-25
- Fix build issues (D-BUS detection)

* Thu Nov 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-24
 - version bump

* Wed Nov 01 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-23
- version bump

* Tue Oct 31 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-22
- Version bump

* Wed Oct 25 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-21
- 211942: Xenvm moniker must be eradicated

* Wed Oct 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-20
- cluster module: mark services as being xenvms, in status report

* Wed Oct 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-19
- Fixed bz 206571 (clustat changed output)
- modclusterd startup/shutdown improvements

* Fri Oct 06 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-18
- Add purge_conf argument to stop_node modcluster call (bz202314)

* Wed Oct 04 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-17
- Version bump

* Fri Sep 25 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-16
- Suppress msgs from init script (bz204235)

* Fri Aug 21 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-14
- Version bump

* Fri Aug 18 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-13
- Version bump

* Wed Aug 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-12
- Move modcluster from /usr/sbin to /usr/libexec
- Implement support for Cluster Suite 5
- Don't auto-start modclusterd after installation, do it manually

* Wed Aug 09 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-11
- Spinoff: separate clustermon.srpm (modcluster, cluster-snmp and
  cluster-cim) from conga.srpm
